<template>
    <div id="calendar" ref="calendar" class="calendar"></div>
</template>

<script>

import axios from "axios"


export default {
    name:"Calendar",
    props:{
        picked: String,
        setHeure: Function
    },
    data(){
        return{
            api_url: "http://localhost:5000/reservations",
            compteur: 0,
            current_date: new Date(),
            events: []
        }
    },
    methods:{
        async dataReservations(){
            let response = ""

            try{
                response = await axios.get(this.api_url)

                return response.data.map(el =>{
                    return {
                        title : el.service,
                        start  : `${el.jour}T${el.heureDebut}`,
                        end : `${el.jour}T${el.heureFin}`,
                        allDay : false,
                        classNames: ["event-calendar","from-api"]
                    }
                })

            } catch(err){
                console.log("Erreur réservation fetch", err)
            }

        },
        formatDate(date){
            return date.split('T')[0]
        },
        formatHeure(date){
            return date.split('T')[1].split('+')[0].substr(0, 5)
        },
        getCompteur(){
            return this.compteur
        },
        setCompteur(value){
            this.compteur = value
        },
        isOverlapping(selectionInfo){

            const start = selectionInfo.start
            const end = selectionInfo.end

            const date = start.getDate()+''+(start.getMonth()+1)+''+start.getFullYear()

            const dates = this.events.filter((el)=>{
                const d = new Date(el.start)
                const ch = d.getDate()+''+(d.getMonth()+1)+''+d.getFullYear()

                return ch === date
            })

            if (dates.length >= 1){
                
                for (let index = 0; index < dates.length; index++) {
                    const el = dates[index];

                    const startEl = new Date(el.start)
                    const endEl = new Date(el.end)

                    if ( (start <= startEl && end >= endEl) || (end <= endEl && end >= startEl) || (start >= startEl && start <= endEl)){
                        return true
                    }   
                }
            }

            return false

        },
        beforeCurrentDate(selectionInfo){
            return (selectionInfo.start < this.current_date)
        }
    },
    async mounted(){
        var calendarEl = this.$refs.calendar

        let events = await this.dataReservations()

        this.events = events

        let vm = this
        
        var calendar = new FullCalendar.Calendar(calendarEl, {
            selectable: true,
            initialView: 'timeGridWeek',
            slotMinTime: '08:00:00',
            slotMaxTime: '21:00:00',
            locale: 'fr',
            buttonText:{
                today: "Aujourd'hui"
            },
            eventOverlap:false,
            events: events,
            select: function(selectionInfo) {
                if (vm.compteur == 0 && !vm.beforeCurrentDate(selectionInfo) && !vm.isOverlapping(selectionInfo)){
                    calendar.addEvent({
                        title: vm.picked,
                        start: selectionInfo.start,
                        end: selectionInfo.end,
                        classNames: ['event-calendar','from-web']
                    });

                    let jour = vm.formatDate(selectionInfo.startStr)

                    let debut = vm.formatHeure(selectionInfo.startStr)
                    let fin = vm.formatHeure(selectionInfo.endStr)

                    vm.setHeure(jour, debut, fin)

                    vm.compteur++
                }


            },
            eventClick: function(data){
                if ( !data.el.classList.contains("from-api")){
                    data.event.remove()
                    vm.compteur--
                }
            }
            
        })
        calendar.render();

    }
}
</script>

<style lang="scss">

@import "../style/default";


.event-calendar{
    font-size: 1em;
}

.from-api{
    background-color:#cf9c51 ;
}

.from-web{
    background-color: $background-green;
}

</style>